<?php
/**
 * Process woo product update.
 *
 * PHP version >= 5
 *
 * @category  ShirteeProducts
 * @package   ShirteeProductsImporter
 * @author    Shirtee Team <mail@shirtee.com>
 * @copyright 2019 Shirtee
 * @license   GTU www.gtu.in
 * @link      www.shirtee.com
 * @since     1.5
 */
set_time_limit(0);
$path       = getcwd();
$root_path  = explode("/wp-content", $path);
require_once $root_path[0].'/wp-load.php';
require_once SHIRTEE_ROOT_DIR.'/includes/classes/class-shirtee-products-importer.php';
$shirtee_importer_obj = new SHIRTEE_IMPORTER();
if (!$shirtee_importer_obj->is_shirtee_plugin_activate() || !$shirtee_importer_obj->is_shirtee_required_plugin_activate()) {
    exit;
}
if ($shirtee_importer_obj->is_migrated() == 'no') {
    return false;
}
global $wpdb;
$import_cron        = "{$wpdb->prefix}shirtee_import_product_insert_cron";
$product_list       = "{$wpdb->prefix}shirtee_import_products";
$limit              = isset($_GET['limit']) && !empty($_GET['limit']) ? $_GET['limit'] : 3;
$settings          = $shirtee_importer_obj->shirtee_settings(); 
$woo_token          = $shirtee_importer_obj->shirtee_settings('woo_token');
$woo_token          = json_decode($woo_token,true);
$consumer_key       = $woo_token['consumer_key'];
$consumer_secret    = $woo_token['consumer_secret'];
$store_url          = home_url( '/' );
$data               = array();
$newcondition       = '';

if (array_key_exists('pmageid', $_REQUEST)) 
{   
    if (!empty($_REQUEST['pmageid'])) 
    {
        //$limit = 1;
        $newcondition = "and mage_id='".$_REQUEST['pmageid']."'";
    }    
}

$products           = $wpdb->get_results("SELECT `ID`,`uid`,`mage_id`,`product_status`,`woo_id`,`publish`  FROM {$import_cron} WHERE status = 1 and product_status='update' {$newcondition} LIMIT {$limit}");

if ( !empty($products) ) {
    try {        
        // if another cron job started
        foreach ($products as $product) {            
            $products_data  = $wpdb->get_row("SELECT * FROM {$product_list} WHERE `product_mage_id` = {$product->mage_id}");

            if( $products_data->is_all_import == 0 && $products_data->is_warehouse == 0 ){
            	$data['products'][] = $product->mage_id;
            }
            $wpdb->update(
                $import_cron,
                array(
                    "status"  => 4
                ),
                array(
                    "mage_id" => $product->mage_id
                )
            );
        }    
        if( !empty($data) )
        {
        	$res_data = $shirtee_importer_obj->execute_curl($data, "product_details");  
            if ($res_data['status'] == "success") {
                $product_details = $res_data['data'];
                if (isset($product_details['synced'])) {
                    foreach ($product_details['synced'] as $product_details) {
                        $product_info           = $product_details['result'];
                        $product_id             = $product_info['product_id'];
                        $product_title          = $product_info['variable_name'];
                        $product_type           = $product_info['campaign_title'];
                        $product_sku            = $product_info['sku'];
                        $product_price          = $product_info['price'];
                        $product_info['options']= $product_details['attributes'];
                        $product_options_new		= json_encode($product_details['attributes']);
                        
                        $product_info['images'] = $product_details['images'];
                         $images = serialize($product_details['images']);
                        $product_detail         = serialize($product_details['result']);
                        $product_attributes     = serialize($product_details['attributes']);
                        $count = countVariation( $product_details['attributes'],$product_details['images'] );
                        $wpdb->update(
                            $product_list,
                            array(
                                "product_title"      => esc_sql($product_title),
                                "product_type"       => esc_sql($product_type),
                                "product_sku"        => "{$product_sku}",
                                "product_data"       => "{$product_detail}",
                                "product_attributes" => "{$product_attributes}",
                                "product_attributes_new" => $product_options_new,
                                "product_price"      => "{$product_price}",
                                "product_images"     => $images,
                                "product_variations" => "{$count}",
                            ),
                            array(
                                "product_mage_id"    => $product_id
                            )
                        );

                    }
                }
            } 
        }
        if(isset($settings['product_status'])){
            $publish_status = $settings['product_status'];
        }else{
             $publish_status = 0;
        } 

        foreach ($products as $product) {
            $product_id     = $product->mage_id;
            $userID         = $product->uid;
            $cronID         = $product->ID;
            $post_status    = $publish_status;
            $publish        = $post_status == 1 ? 'publish' : 'draft';//check product status             
            $callAPI        = true;
            $images         = '';
            $Pstatus        = $product->product_status;
            $uid            = $product->uid != '' ? $product->uid : 1;
            $insert_id      = $product->woo_id != 0 ? $product->woo_id : '';
            $products_data  = $wpdb->get_row("SELECT * FROM {$product_list} WHERE `product_mage_id` = {$product->mage_id} AND `status` = 1");


            //new API Data
            if (empty($products_data)) { //if product data empty then cron status 2
                $wpdb->update(
                    $import_cron,
                    array(
                        "status"  => 2
                    ),
                    array(
                        "mage_id" => $product->mage_id
                    )
                );
                continue;
            }

            $productData = array();            
          
            if( $products_data->product_variations != 0){ //check if variaion avialable then product create                
                $pID                = $products_data->ID;
                
                if( $products_data->is_all_import == 1 || $products_data->is_warehouse == 1 )
                {
                    $result 					= json_decode($products_data->product_data,true);
                    $product_options            = json_decode($products_data->product_attributes,true);
                	$product_images             = json_decode($products_data->product_images,true); 
                 } else {
                	$result                     = unserialize($products_data->product_data);
                    if( !empty($products_data->product_attributes_new) ){
                        $product_options        = json_decode($products_data->product_attributes_new, true);
                    } else {
                        $product_options        = unserialize($products_data->product_attributes);
                    }                    
                	$product_images             = unserialize($products_data->product_images);                          
                }


                if( isset($result['ean_sku']) && (!empty($result['ean_sku'])) ){ 
                    $wpdb->update(
                        $import_cron,
                        array('status' => 0, 'product_status' => 'update','woo_id' => $insert_id),
                        array('mage_id' => $product_id)
                    );
                    $wpdb->update(
                        $product_list,
                        array('product_woo_id' => $insert_id),
                        array('product_mage_id' => $product_id)
                    );
                    
                    
                    $data = array(
                        "product_mage_id" => $product_id,
                        "product_woo_url" => get_the_permalink($insert_id),
                        "product_woo_id"  => $insert_id,
                    );
                    $shirtee_importer_obj->execute_curl($data, "update_details");
                    return false;
                } 
              //  if( isset($result['ean_sku']) && (!empty($result['ean_sku'])) ){ //Check EAN Code in warehouse
                //    $sku                            = $result['ean_sku'];
                //} else {
                $sku                            = $result['sku'];
                //}              
                
               //echo "count".count( $product_options[
                
                $name               = trim($result['campaign_title']); 
                
                $price              = $result['price'];
                $regular_price      = $result['price'];                        
                $description        = $result['description'];
               // $description            = trim($result['campaign_title']); 
                  /* Meta Details*/
                $meta_title                    = $result['meta_title'];
                $meta_keyword                  = $result['meta_keyword'];
                $meta_description              = $result['meta_description'];

                $short_description  = "<ul>";
                $short_description .= !empty($result['amazon_bulletpoint1']) ? "<li>{$result['amazon_bulletpoint1']}</li>" : "";
                $short_description .= !empty($result['amazon_bulletpoint2']) ? "<li>{$result['amazon_bulletpoint2']}</li>" : "";
                $short_description .= !empty($result['amazon_bulletpoint3']) ? "<li>{$result['amazon_bulletpoint3']}</li>" : "";
                $short_description .= !empty($result['amazon_bulletpoint4']) ? "<li>{$result['amazon_bulletpoint4']}</li>" : "";
                $short_description .= !empty($result['amazon_bulletpoint5']) ? "<li>{$result['amazon_bulletpoint5']}</li>" : "";
                $short_description .= "</ul>";
                $attribute          = array_values($product_options );
                $type               = "variable";
                /*if ( $products_data->product_variations == 1) {
                    $type = "simple";                    
                }   */
               // $result['options']  = unserialize($products_data->product_attributes);
                $result['options']              = $product_options;
                $result['images']               = $product_images;
                $optionsData = "";
                if( $type == "variable"){                   
                    $optionsData    = productAttributeCreate($result);
                }

                $colorValue         = array();
                 
                //check images alread exist or not end

                foreach( $attribute[1]['additional_fields'] as $colorvar ){
                    $colorValue[]   = $colorvar['value_id'];
                }
                $i=0;

                if(isset($settings['product_image']) && $settings['product_image'] == '0')
                {
                    $img                = array();
                    $mainimge           = array();                
                    //check images alread exist or not
                    $posts = "{$wpdb->prefix}posts";
                    $image_id   = $wpdb->get_results("SELECT ID,post_title,guid FROM {$posts} WHERE post_title LIKE '%".$sku."%' and post_title != '".$sku."-Measure'and post_type='attachment'");
                    
                    $proImage =array();
                    $proImageData =array();
                   
                    if( !empty($image_id)){
                        $i=0;
                        foreach( $image_id as $simage ){
                            $proImage[]             = $simage->post_title;                       
                            $proImageData[$i]['ID'] = $simage->ID;
                            $i++;
                        }
                    }
                    foreach($product_images as $product_image){
                        if (in_array($product_image['label'], $colorValue)){
                            if( ! in_array(($sku."-".$product_image['label']), $proImage) ){
                                $url = $product_image['url'];
                                $redirectedUrl = "";
    							if( $products_data->is_warehouse == 1 ){
    								$redirectedUrl = $url;
    							} else {
                                    $ch = curl_init(); 
                                    curl_setopt($ch, CURLOPT_URL, $url); 
                                    curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE); 
                                    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE); 
                                    $html = curl_exec($ch); 
                                    $redirectedUrl = curl_getinfo($ch, CURLINFO_EFFECTIVE_URL); 
                                }
                               
                                $mainimge[$i]['src'] = $redirectedUrl;
                                $mainimge[$i]['name'] = $sku."-".$product_image['label'];                            
                            } else {                           
                                $value = $sku."-".$product_image['label'];
                                $image_id   = $wpdb->get_results("SELECT ID FROM {$posts} WHERE post_title= '".$value."' and post_type='attachment'");
                                $pid = "";
                                if( !empty($image_id)){
                                    $pid = $image_id[0]->ID;
                                }   
                                $mainimge[$i]['id'] = $pid;                           
                            }
                            $i++;
                        }                   
                    }
                }

                if( empty($result['ean_sku']) ){ //Check EAN Code in warehouse
                $weight                         = $result['weight'];
                $length                         = $result['length'];
                $width                          = $result['width'];
                $height                         = $result['height'];
                 if(isset($settings['product_title']) && $settings['product_title'] == '0'){
                        $productData['name'] = $name;
                     } 
               
                $productData['type']            = $type;
                $productData['price']           = "$price";
                if(isset($settings['product_price']) && $settings['product_price'] == '1')
                {
                     //$productData['regular_price']   = "$regular_price";
                    $_product = wc_get_product( $insert_id );
                    $regular_price = $_product->get_price();
                    $productData['regular_price']   = "$regular_price";
                }
                   if(isset($settings['product_description']) && $settings['product_description'] == '0'){
                         $productData['description']  = $description;
                         
                }

                /* Meta Details*/
                $productData['meta_data'] = [[ 'key'=>'meta_title', 'value'=>$meta_title ], [ 'key'=>'meta_keyword', 'value'=>$meta_keyword ], [ 'key'=>'meta_description', 'value'=>$meta_description ] ];
                
                $productData['short_description'] = $short_description;
                $productData['sku']             = $sku;
                if( $products_data->is_warehouse != 1 ){
                $productData['attributes']      = $optionsData;
                }
                
                if(isset($settings['product_image']) && $settings['product_image'] == '0')
                {
                    $productData['images']          = $mainimge;
                }
                $productData['manage_stock']    = false;
                if( $products_data->is_warehouse != 1 ){
                  $productData['manage_stock']    = true;
                  $productData['stock_quantity']  = "10000";
                }
                $productData['in_stock']        = true;
                $productData['weight']          = $weight;
                $productData['length']          = $length;
                $productData['width']           = $width;
                $productData['height']          = $height;
                $productData['status']          = $publish;  
                }
                
               
                $productData                    = json_encode($productData);  

                $url  = restApiUrl($store_url.'wp-json/wc/v3/products/'.$insert_id,$consumer_key,$consumer_secret);
                $res_data                       = restApiCurlData($url, $productData);    //update product data  
               
                if( !empty($res_data) ){ //create product variation 
                    $postid                     = $res_data['id'];
                    update_post_meta($postid, 'product_imported', 'yes');
                    if ($result['is_customize_product'] == 1) {
                        update_post_meta($postid, 'is_customize', 1);
                    }
                    $images                     = $res_data['images'];
                    
                    if (  $products_data->product_variations != 0 ) { //check product simple or variation 
                        $varData                    = array();
                        $warehouse = 0;
                        
                        
                        if( $products_data->is_warehouse == 1 ){
                            $warehouse = 1;
                        }
                        $varData                = createVariation($sku,$attribute,$product_images,$regular_price,$warehouse); 
                        //check existing sku and create different existing update new insert
                        $existSKU = array();
                        if( !empty($res_data['variations'])  ){
                            foreach($res_data['variations'] as $variation)
                            {
                                $existSKU[] = get_post_meta($variation, "_sku", true);
                            }
                        }
                        $createVarData = array();
                        $updateVarData = array();


                        foreach( $varData as $svarition ){                        
                            if (!in_array($svarition['sku'], $existSKU ) ) {
                                $createVarData[] = $svarition;
                            } else {
                                $key = "_sku";
                                $value = $svarition['sku'];
                                $meta = $wpdb->get_results( $wpdb->prepare( "SELECT post_id FROM ".$wpdb->postmeta." WHERE meta_key=%s AND meta_value=%s order by  meta_id desc ", $key, $value ) );
                                $pid = 0;
                                if( !empty($meta)){
                                    $pid = $meta[0]->post_id;
                                }                            
                                $svarition['id'] = intval($pid);
                                if(isset($settings['product_image']) && $settings['product_image'] == '1')
                                {
                                    unset($svarition['image']);
                                }
                                $updateVarData[] = $svarition;
                            }   
                        }

                        $vartionCreateData = array();  
                        if( !empty($createVarData) ){
                            $vartionCreateData['create'] = $createVarData;   
                        }
                        if( !empty($updateVarData) ){
                            $vartionCreateData['update'] = $updateVarData;   
                        }


                        $vartionCreateData = json_encode($vartionCreateData);        


                        $url  = restApiUrl($store_url.'wp-json/wc/v3/products/'.$postid.'/variations/batch',$consumer_key,$consumer_secret);
                        $res_data       = restApiCurlData($url, $vartionCreateData);
                        
                         
                        
                        if( isset($res_data['data']['status']) && ($res_data['data']['status'] == "401") ){
                            $wpdb->update(
                                $import_cron,
                                array('status'=>1),
                                array('mage_id' => $product_id)
                            );
                            continue;
                        }
                        
                        //exit;
                        
                       	
                        
                    }
                    if(!empty($res_data) ){                       
                        $data = array(
                            "product_mage_id" => $product_id,
                            "product_woo_url" => get_the_permalink($postid),
                            "product_woo_id"  => $postid,
                        );
                        $res_data = $shirtee_importer_obj->execute_curl($data, "update_details"); //uddate product in shirtee cloud
						
                        $productsData['sku']         = $sku;
                        $productsData['image_title'] = $products_data->product_type;
                        $productsData['images']      = $images;
                        if(isset($settings['product_image']) && $settings['product_image'] == '0')
                        {
                            $state = create_measure_image($productsData);
                            updateProductImages($postid,$sku,$images);
                        }
                        
                        $wpdb->update(
                            $import_cron,
                            array('status'=> 0,'updated_at'=>current_time('mysql'),'woo_id'=> $postid),
                            array('ID' => $cronID)
                        );
                        $wpdb->update(
                            $product_list,
                            array('product_woo_id'  => $postid),
                            array('product_mage_id' => $product_id)
                        );
                    }
                } else {
                    $shirtee_importer_obj->send_emails("<p>Product ID :: ".$product->mage_id.".</p>", "Product not updated in woo");
                }
            }
            //new API Data close
        }
    } catch (EXCEPTION $e) {
        $wpdb->update(
            $import_cron,
            array('status'=>0,'updated_at' => current_time('mysql')),
            array('ID' => $product->ID)
        );
        $shirtee_importer_obj->send_emails("<p>".$e->getMessage()."</p><p>Product ID :: ".$product->mage_id.".</p>", "Product not updated in woo");
        return false;
    }
}